package com.daylight;

import com.daylight.Smiles;
public class Finger {

    /* functions */
    private static native int jdt_fp_allocfp(int size);
    public static int dt_fp_allocfp(int size) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_allocfp(size);
        }
    }

    private static native int jdt_fp_bitcount(int fp);
    public static int dt_fp_bitcount(int fp) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_bitcount(fp);
        }
    }

    private static native int jdt_fp_bitvalue(int fp, int bitno);
    public static int dt_fp_bitvalue(int fp, int bitno) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_bitvalue(fp, bitno);
        }
    }

    private static native int jdt_fp_commonbitcount(int fp1, int fp2);
    public static int dt_fp_commonbitcount(int fp1, int fp2) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_commonbitcount(fp1, fp2);
        }
    }

    private static native int jdt_fp_differencefp(int ob, int min, int max, int size);
    public static int dt_fp_differencefp(int ob, int min, int max, int size) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_differencefp(ob, min, max, size);
        }
    }

    private static native float jdt_fp_euclid(int fpt, int fpo);
    public static float dt_fp_euclid(int fpt, int fpo) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_euclid(fpt, fpo);
        }
    }

    private static native int jdt_fp_fingertest(int fpt, int fpo);
    public static int dt_fp_fingertest(int fpt, int fpo) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_fingertest(fpt, fpo);
        }
    }

    private static native boolean jdt_fp_foldfp(int fp, int minsize, float mindensity);
    public static boolean dt_fp_foldfp(int fp, int minsize, float mindensity) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_foldfp(fp, minsize, mindensity);
        }
    }

    private static native int jdt_fp_generatefp(int ob, int min, int max, int size);
    public static int dt_fp_generatefp(int ob, int min, int max, int size) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_generatefp(ob, min, max, size);
        }
    }

    private static native int jdt_fp_nbits(int fp);
    public static int dt_fp_nbits(int fp) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_nbits(fp);
        }
    }

    private static native int jdt_fp_obitcount(int fp);
    public static int dt_fp_obitcount(int fp) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_obitcount(fp);
        }
    }

    private static native int jdt_fp_obits(int fp);
    public static int dt_fp_obits(int fp) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_obits(fp);
        }
    }

    private static native int jdt_fp_partfp(int part, int ob, int min, int max, int size);
    public static int dt_fp_partfp(int part, int ob, int min, int max, int size) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_partfp(part, ob, min, max, size);
        }
    }

    private static native String jdt_fp_range(int fp, int offset, int nbits, int[] soffset);
    public static String dt_fp_range(int fp, int offset, int nbits, int[] soffset) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_range(fp, offset, nbits, soffset);
        }
    }

    private static native boolean jdt_fp_setbitvalue(int fp, int bitno, boolean value);
    public static boolean dt_fp_setbitvalue(int fp, int bitno, boolean value) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_setbitvalue(fp, bitno, value);
        }
    }

    private static native boolean jdt_fp_setobitcount(int fp, int obitcount);
    public static boolean dt_fp_setobitcount(int fp, int obitcount) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_setobitcount(fp, obitcount);
        }
    }

    private static native boolean jdt_fp_setobits(int fp, int obits);
    public static boolean dt_fp_setobits(int fp, int obits) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_setobits(fp, obits);
        }
    }

    private static native int jdt_fp_setrange(int fp, int offset, int nbits, String str, int soffset, int operation);
    public static int dt_fp_setrange(int fp, int offset, int nbits, String str, int soffset, int operation) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_setrange(fp, offset, nbits, str, soffset, operation);
        }
    }

    private static native int jdt_fp_similarity(int fpt, int fpo, String s);
    public static int dt_fp_similarity(int fpt, int fpo, String s) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_similarity(fpt, fpo, s);
        }
    }

    private static native float jdt_fp_tanimoto(int fpt, int fpo);
    public static float dt_fp_tanimoto(int fpt, int fpo) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_tanimoto(fpt, fpo);
        }
    }

    private static native float jdt_fp_tversky(int fpa, int fpb, float alpha, float beta);
    public static float dt_fp_tversky(int fpa, int fpb, float alpha, float beta) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_tversky(fpa, fpb, alpha, beta);
        }
    }

    private static native int jdt_fp_alloc();
    public static int dt_fp_alloc() {
        synchronized(Smiles.LockObject) {
            return jdt_fp_alloc();
        }
    }

    private static native int jdt_fp_fingerprint(int mol, boolean dofold);
    public static int dt_fp_fingerprint(int mol, boolean dofold) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_fingerprint(mol, dofold);
        }
    }

    private static native boolean jdt_fp_fold(int fp);
    public static boolean dt_fp_fold(int fp) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_fold(fp);
        }
    }

    private static native float jdt_fp_mindensity();
    public static float dt_fp_mindensity() {
        synchronized(Smiles.LockObject) {
            return jdt_fp_mindensity();
        }
    }

    private static native int jdt_fp_minsize();
    public static int dt_fp_minsize() {
        synchronized(Smiles.LockObject) {
            return jdt_fp_minsize();
        }
    }

    private static native float jdt_fp_setmindensity(float d);
    public static float dt_fp_setmindensity(float d) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_setmindensity(d);
        }
    }

    private static native int jdt_fp_setminsize(int bits);
    public static int dt_fp_setminsize(int bits) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_setminsize(bits);
        }
    }

    private static native int jdt_fp_setsize(int bits);
    public static int dt_fp_setsize(int bits) {
        synchronized(Smiles.LockObject) {
            return jdt_fp_setsize(bits);
        }
    }

    private static native int jdt_fp_size();
    public static int dt_fp_size() {
        synchronized(Smiles.LockObject) {
            return jdt_fp_size();
        }
    }

    /* End of functions */

    // Constants

    public static final int     DT_FINGER_INCLUDED     = 1;
    public static final int     DX_FP_SET              = 0;
    public static final int     DX_FP_NOT              = 1;
    public static final int     DX_FP_AND              = 2;
    public static final int     DX_FP_OR               = 3;
    public static final int     DX_FP_XOR              = 4;

    // end of constants

    static { System.loadLibrary("dj"); }

    /////////////// END
}
