package com.daylight;

import com.daylight.Smiles;
public class Merlin {

    /* functions */
    private static native int jdt_mer_server(String host, String service, String userid, String password, int[] isnew);
    public static int dt_mer_server(String host, String service, String userid, String password, int[] isnew) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_server(host, service, userid, password, isnew);
        }
    }

    private static native String jdt_mer_action2name(int server, int iaction);
    public static String dt_mer_action2name(int server, int iaction) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_action2name(server, iaction);
        }
    }

    private static native String jdt_mer_function2name(int server, int ifunc);
    public static String dt_mer_function2name(int server, int ifunc) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_function2name(server, ifunc);
        }
    }

    private static native String jdt_mer_search2name(int server, int isearch);
    public static String dt_mer_search2name(int server, int isearch) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_search2name(server, isearch);
        }
    }

    private static native String jdt_mer_similar2name(int server, int isimilar);
    public static String dt_mer_similar2name(int server, int isimilar) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_similar2name(server, isimilar);
        }
    }

    private static native String jdt_mer_sort2name(int server, int isort);
    public static String dt_mer_sort2name(int server, int isort) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_sort2name(server, isort);
        }
    }

    private static native String jdt_mer_subselect2name(int server, int isubselect);
    public static String dt_mer_subselect2name(int server, int isubselect) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_subselect2name(server, isubselect);
        }
    }

    private static native String jdt_mer_superselect2name(int server, int isuperselect);
    public static String dt_mer_superselect2name(int server, int isuperselect) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_superselect2name(server, isuperselect);
        }
    }

    private static native String jdt_mer_progob2name(int server, int iprogob);
    public static String dt_mer_progob2name(int server, int iprogob) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_progob2name(server, iprogob);
        }
    }

    private static native int jdt_mer_nactions(int server);
    public static int dt_mer_nactions(int server) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_nactions(server);
        }
    }

    private static native int jdt_mer_nfunctions(int server);
    public static int dt_mer_nfunctions(int server) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_nfunctions(server);
        }
    }

    private static native int jdt_mer_nsearches(int server);
    public static int dt_mer_nsearches(int server) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_nsearches(server);
        }
    }

    private static native int jdt_mer_nsimilars(int server);
    public static int dt_mer_nsimilars(int server) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_nsimilars(server);
        }
    }

    private static native int jdt_mer_nsorts(int server);
    public static int dt_mer_nsorts(int server) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_nsorts(server);
        }
    }

    private static native int jdt_mer_nsubselects(int server);
    public static int dt_mer_nsubselects(int server) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_nsubselects(server);
        }
    }

    private static native int jdt_mer_nsuperselects(int server);
    public static int dt_mer_nsuperselects(int server) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_nsuperselects(server);
        }
    }

    private static native int jdt_mer_nprogobs(int server);
    public static int dt_mer_nprogobs(int server) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_nprogobs(server);
        }
    }

    private static native int jdt_mer_getnitems(int pool, int dtype);
    public static int dt_mer_getnitems(int pool, int dtype) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_getnitems(pool, dtype);
        }
    }

    private static native int jdt_mer_alloc_column(int pool, int ftype, int functype);
    public static int dt_mer_alloc_column(int pool, int ftype, int functype) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_alloc_column(pool, ftype, functype);
        }
    }

    private static native int jdt_mer_function(int col);
    public static int dt_mer_function(int col) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_function(col);
        }
    }

    private static native int jdt_mer_alloc_hitlist(int pool);
    public static int dt_mer_alloc_hitlist(int pool) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_alloc_hitlist(pool);
        }
    }

    private static native int jdt_mer_clear(int hit);
    public static int dt_mer_clear(int hit) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_clear(hit);
        }
    }

    private static native int jdt_mer_combinehitlists(int hith1, int hh2, int action);
    public static int dt_mer_combinehitlists(int hith1, int hh2, int action) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_combinehitlists(hith1, hh2, action);
        }
    }

    private static native int jdt_mer_hit2id(int hit, int ihit);
    public static int dt_mer_hit2id(int hit, int ihit) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_hit2id(hit, ihit);
        }
    }

    private static native int jdt_mer_id2hit(int hit, int id);
    public static int dt_mer_id2hit(int hit, int id) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_id2hit(hit, id);
        }
    }

    private static native int jdt_mer_invert(int hit);
    public static int dt_mer_invert(int hit) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_invert(hit);
        }
    }

    private static native int jdt_mer_length(int hit);
    public static int dt_mer_length(int hit) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_length(hit);
        }
    }

    private static native int jdt_mer_mvbottom(int hit, int ihit);
    public static int dt_mer_mvbottom(int hit, int ihit) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_mvbottom(hit, ihit);
        }
    }

    private static native int jdt_mer_mvtop(int hit, int ihit);
    public static int dt_mer_mvtop(int hit, int ihit) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_mvtop(hit, ihit);
        }
    }

    private static native int jdt_mer_native(int hit);
    public static int dt_mer_native(int hit) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_native(hit);
        }
    }

    private static native int jdt_mer_reset(int hit);
    public static int dt_mer_reset(int hit) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_reset(hit);
        }
    }

    private static native int jdt_mer_reverse(int hit);
    public static int dt_mer_reverse(int hit) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_reverse(hit);
        }
    }

    private static native int jdt_mer_sethits(int hit, int ch, int sq);
    public static int dt_mer_sethits(int hit, int ch, int sq) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_sethits(hit, ch, sq);
        }
    }

    private static native int jdt_mer_zapabove(int hit, int ihit);
    public static int dt_mer_zapabove(int hit, int ihit) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_zapabove(hit, ihit);
        }
    }

    private static native int jdt_mer_zapbelow(int hit, int ihit);
    public static int dt_mer_zapbelow(int hit, int ihit) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_zapbelow(hit, ihit);
        }
    }

    private static native int jdt_mer_zapna(int hit, int col);
    public static int dt_mer_zapna(int hit, int col) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_zapna(hit, col);
        }
    }

    private static native int jdt_mer_zapnonunique(int hit, int col);
    public static int dt_mer_zapnonunique(int hit, int col) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_zapnonunique(hit, col);
        }
    }

    private static native int jdt_mer_sort(int hit, int col, int sort, int ascending, int[] pret_status);
    public static int dt_mer_sort(int hit, int col, int sort, int ascending, int[] pret_status) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_sort(hit, col, sort, ascending, pret_status);
        }
    }

    private static native int jdt_mer_strsearch(int hit, int col, int search, int action, int find_next, int[] ret_status, String s1, String s2);
    public static int dt_mer_strsearch(int hit, int col, int search, int action, int find_next, int[] ret_status, String s1, String s2) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_strsearch(hit, col, search, action, find_next, ret_status, s1, s2);
        }
    }

    private static native int jdt_mer_numsearch(int hit, int col, int action, int find_next, int[] ret_status, float low, float high);
    public static int dt_mer_numsearch(int hit, int col, int action, int find_next, int[] ret_status, float low, float high) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_numsearch(hit, col, action, find_next, ret_status, low, high);
        }
    }

    private static native int jdt_mer_subselect(int hit, int col, int searchtype, int action, int find_next, int[] ret_status, String smiles);
    public static int dt_mer_subselect(int hit, int col, int searchtype, int action, int find_next, int[] ret_status, String smiles) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_subselect(hit, col, searchtype, action, find_next, ret_status, smiles);
        }
    }

    private static native int jdt_mer_superselect(int hit, int col, int searchtype, int action, int find_next, int[] ret_status, String smiles);
    public static int dt_mer_superselect(int hit, int col, int searchtype, int action, int find_next, int[] ret_status, String smiles) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_superselect(hit, col, searchtype, action, find_next, ret_status, smiles);
        }
    }

    private static native int jdt_mer_similarselect(int hit, int col, int similartype, int action, int find_next, int[] ret_status, String smiles, float limit, float alpha, float beta);
    public static int dt_mer_similarselect(int hit, int col, int similartype, int action, int find_next, int[] ret_status, String smiles, float limit, float alpha, float beta) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_similarselect(hit, col, similartype, action, find_next, ret_status, smiles, limit, alpha, beta);
        }
    }

    private static native int jdt_mer_progob_compare(int hit, int target_col, int results_col, int iprogob, int pattern_bin, int parameters, int[] pstatus);
    public static int dt_mer_progob_compare(int hit, int target_col, int results_col, int iprogob, int pattern_bin, int parameters, int[] pstatus) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_progob_compare(hit, target_col, results_col, iprogob, pattern_bin, parameters, pstatus);
        }
    }

    private static native int jdt_mer_progob_compute(int pool, int iprogob, int strobj, int parms);
    public static int dt_mer_progob_compute(int pool, int iprogob, int strobj, int parms) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_progob_compute(pool, iprogob, strobj, parms);
        }
    }

    private static native int jdt_mer_progob_computeparams(int pool, int iprogob);
    public static int dt_mer_progob_computeparams(int pool, int iprogob) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_progob_computeparams(pool, iprogob);
        }
    }

    private static native int jdt_mer_progob_compareparams(int pool, int iprogob);
    public static int dt_mer_progob_compareparams(int pool, int iprogob) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_progob_compareparams(pool, iprogob);
        }
    }

    private static native int jdt_mer_similar(int hit, int col, int similartype, int action, int find_next, int[] ret_status, String smiles, float limit);
    public static int dt_mer_similar(int hit, int col, int similartype, int action, int find_next, int[] ret_status, String smiles, float limit) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_similar(hit, col, similartype, action, find_next, ret_status, smiles, limit);
        }
    }

    private static native String jdt_mer_cellvalue(int col, int hit, int ihit);
    public static String dt_mer_cellvalue(int col, int hit, int ihit) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_cellvalue(col, hit, ihit);
        }
    }

    private static native String jdt_mer_getdata(int hit, int ihit, int ftype, int nth);
    public static String dt_mer_getdata(int hit, int ihit, int ftype, int nth) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_getdata(hit, ihit, ftype, nth);
        }
    }

    private static native String jdt_mer_getroot(int hit, int ihit);
    public static String dt_mer_getroot(int hit, int ihit) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_getroot(hit, ihit);
        }
    }

    private static native int jdt_mer_defaultsort(int col);
    public static int dt_mer_defaultsort(int col) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_defaultsort(col);
        }
    }

    private static native boolean jdt_mer_sortapplies(int col, int sort);
    public static boolean dt_mer_sortapplies(int col, int sort) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_sortapplies(col, sort);
        }
    }

    private static native boolean jdt_mer_funcapplies(int ftype, int function);
    public static boolean dt_mer_funcapplies(int ftype, int function) {
        synchronized(Smiles.LockObject) {
            return jdt_mer_funcapplies(ftype, function);
        }
    }

    /* End of functions */

    // Constants

    public static final int     DT_MERLIN_INCLUDED     = 1;
    public static final String  DX_THOR_USER           = "thor";
    public static final String  DX_INFO_USER           = "thorinfo";
    public static final String  DX_TAG_SIMILARITY      = "SIMILARITY";
    public static final String  DX_TAG_SMILES          = "$SMI";
    public static final String  DX_TAG_ISOSMILES       = "$ISM";
    public static final String  DX_TAG_FINGERPRINT     = "FP";
    public static final int     DX_FUNC_FIRST          = 0;
    public static final int     DX_FUNC_LAST           = 1;
    public static final int     DX_FUNC_MIN            = 2;
    public static final int     DX_FUNC_MAX            = 3;
    public static final int     DX_FUNC_LONGEST        = 4;
    public static final int     DX_FUNC_SHORTEST       = 5;
    public static final int     DX_FUNC_ALL            = 6;
    public static final int     DX_FUNC_AVG            = 7;
    public static final int     DX_FUNC_STDDEV         = 8;
    public static final int     DX_FUNC_COUNT          = 9;
    public static final int     DM_NFUNCS              = 10;
    public static final int     DX_SORT_ASC            = 0;
    public static final int     DX_SORT_ANC            = 1;
    public static final int     DX_SORT_ANP            = 2;
    public static final int     DX_SORT_ANW            = 3;
    public static final int     DX_SORT_ANCP           = 4;
    public static final int     DX_SORT_ANCW           = 5;
    public static final int     DX_SORT_ANPW           = 6;
    public static final int     DX_SORT_ANCPW          = 7;
    public static final int     DX_SORT_AAZ            = 8;
    public static final int     DX_SORT_NUM            = 9;
    public static final int     DX_SORT_NAB            = 10;
    public static final int     DX_SORT_CAS            = 11;
    public static final int     DX_SORT_MFM            = 12;
    public static final int     DX_SORT_LEN            = 13;
    public static final int     DM_NSORTS              = 14;
    public static final int     DX_ACTION_NEW_LIST     = 0;
    public static final int     DX_ACTION_ADD_HITS     = 1;
    public static final int     DX_ACTION_ADD_NONHITS  = 2;
    public static final int     DX_ACTION_DEL_HITS     = 3;
    public static final int     DX_ACTION_DEL_NONHITS  = 4;
    public static final int     DX_ACTION_NEXT_HIT     = 5;
    public static final int     DX_ACTION_NEXT_NONHIT  = 6;
    public static final int     DM_NACTIONS            = 7;
    public static final int     DX_STRING_ASCII        = 0;
    public static final int     DX_STRING_NC           = 1;
    public static final int     DX_STRING_NW           = 2;
    public static final int     DX_STRING_NP           = 3;
    public static final int     DX_STRING_NCW          = 4;
    public static final int     DX_STRING_NCP          = 5;
    public static final int     DX_STRING_NPW          = 6;
    public static final int     DX_STRING_NCPW         = 7;
    public static final int     DX_STRING_REGEXP       = 8;
    public static final int     DX_STRING_APPROX       = 9;
    public static final int     DM_NSTRINGS            = 10;
    public static final int     DX_SUPER_SMILES        = 0;
    public static final int     DX_SUPER_SMARTS        = 1;
    public static final int     DX_SUPER_CHARTS        = 2;
    public static final int     DX_SUPER_SMILESPART    = 3;
    public static final int     DX_SUPER_SMARTSPART    = 4;
    public static final int     DM_NSUPERS             = 5;
    public static final int     DX_SUBSTRUCT_SMILES    = 0;
    public static final int     DM_NSUBSTRUCTS         = 1;
    public static final int     DX_SIMILAR_TANIMOTO    = 0;
    public static final int     DX_SIMILAR_EUCLIDIAN   = 1;
    public static final int     DX_SIMILAR_TVERSKY     = 2;
    public static final int     DM_NSIMILAR            = 3;
    public static final int     DX_STATUS_IN_PROGRESS  = 0;
    public static final int     DX_STATUS_DONE         = 1;
    public static final int     DX_STATUS_NOT_FOUND    = 2;
    public static final int     DX_STATUS_ERROR        = 3;
    public static final int     DX_MESSAGE_NONE        = 0;
    public static final int     DX_MESSAGE_NOW         = 1;
    public static final int     DX_MESSAGE_RECORD      = 2;
    public static final int     DX_MESSAGE_FILE        = 3;

    // end of constants

    static { System.loadLibrary("dj");     }

    /////////////// END
}
