package com.daylight;

import com.daylight.Smiles;
public class Smarts {

    /* functions */
    private static native int jdt_alloc_pathset(int m);
    public static int dt_alloc_pathset(int m) {
        synchronized(Smiles.LockObject) {
	    return jdt_alloc_pathset(m);
	}
    }

    private static native int jdt_alloc_vbind(String s);
    public static int dt_alloc_vbind(String s) {
        synchronized(Smiles.LockObject) {
            return jdt_alloc_vbind(s);
        }
    }

    private static native int jdt_getval(int ob);
    public static int dt_getval(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_getval(ob);
        }
    }

    private static native int jdt_match(int ob, int mol, int exists);
    public static int dt_match(int ob, int mol, int exists) {
        synchronized(Smiles.LockObject) {
            return jdt_match(ob, mol, exists);
        }
    }

    private static native int jdt_pattern(int transform, int role);
    public static int dt_pattern(int transform, int role) {
        synchronized(Smiles.LockObject) {
            return jdt_pattern(transform, role);
        }
    }

    private static native boolean jdt_setval(int ob, int val);
    public static boolean dt_setval(int ob, int val) {
        synchronized(Smiles.LockObject) {
            return jdt_setval(ob, val);
        }
    }

    private static native int jdt_smartin(String s);
    public static int dt_smartin(String s) {
        synchronized(Smiles.LockObject) {
            return jdt_smartin(s);
        }
    }

    private static native String jdt_smarts_opt(String s, boolean vmatch);
    public static String dt_smarts_opt(String s, boolean vmatch) {
        synchronized(Smiles.LockObject) {
            return jdt_smarts_opt(s, vmatch);
        }
    }

    private static native int jdt_smirkin(String string);
    public static int dt_smirkin(String string) {
        synchronized(Smiles.LockObject) {
            return jdt_smirkin(string);
        }
    }

    private static native int jdt_transform(int transform, int som, boolean direction, int limit);
    public static int dt_transform(int transform, int som, boolean direction, int limit) {
        synchronized(Smiles.LockObject) {
            return jdt_transform(transform, som, direction, limit);
        }
    }

    private static native int jdt_utransform(int transform, int som, boolean direction, int limit);
    public static int dt_utransform(int transform, int som, boolean direction, int limit) {
        synchronized(Smiles.LockObject) {
            return jdt_utransform(transform, som, direction, limit);
        }
    }

    private static native int jdt_xtransform(int transform, int som, boolean direction, int limit);
    public static int dt_xtransform(int transform, int som, boolean direction, int limit) {
        synchronized(Smiles.LockObject) {
            return jdt_xtransform(transform, som, direction, limit);
        }
    }

    private static native int jdt_umatch(int ob, int mol, int ex);
    public static int dt_umatch(int ob, int mol, int ex) {
        synchronized(Smiles.LockObject) {
            return jdt_umatch(ob, mol, ex);
        }
    }

    private static native int jdt_vmatch(int ob, int mol, int ex);
    public static int dt_vmatch(int ob, int mol, int ex) {
        synchronized(Smiles.LockObject) {
            return jdt_vmatch(ob, mol, ex);
        }
    }

    private static native int jdt_xmatch(int ob, int mol, int ex);
    public static int dt_xmatch(int ob, int mol, int ex) {
        synchronized(Smiles.LockObject) {
            return jdt_xmatch(ob, mol, ex);
        }
    }

    /* End of functions */

    // Constants

    // end of constants

    static { System.loadLibrary("dj"); }

    /////////////// END
}
