package com.daylight;

import com.daylight.Smiles;
public class Thor {

    /* functions */
    private static native int jdt_thor_alloc_dataitem(int tdt, int dtype);
    public static int dt_thor_alloc_dataitem(int tdt, int dtype) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_alloc_dataitem(tdt, dtype);
        }
    }

    private static native float jdt_thor_autocrunch_limit(int db, float limit);
    public static float dt_thor_autocrunch_limit(int db, float limit) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_autocrunch_limit(db, limit);
        }
    }

    private static native int jdt_thor_cache(int db, int level);
    public static int dt_thor_cache(int db, int level) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_cache(db, level);
        }
    }

    private static native int jdt_thor_cachecontrol(int db, int when, int level);
    public static int dt_thor_cachecontrol(int db, int when, int level) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_cachecontrol(db, when, level);
        }
    }

    private static native int jdt_thor_cachesync(int db);
    public static int dt_thor_cachesync(int db) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_cachesync(db);
        }
    }

    private static native int jdt_thor_createdb(int server_handle, String path, int size_d, int size_x);
    public static int dt_thor_createdb(int server_handle, String path, int size_d, int size_x) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_createdb(server_handle, path, size_d, size_x);
        }
    }

    private static native int jdt_thor_crunchdata(int db);
    public static int dt_thor_crunchdata(int db) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_crunchdata(db);
        }
    }

    private static native int jdt_thor_crunchxref(int db);
    public static int dt_thor_crunchxref(int db) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_crunchxref(db);
        }
    }

    private static native boolean jdt_thor_destroy(int server, String path, String password);
    public static boolean dt_thor_destroy(int server, String path, String password) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_destroy(server, path, password);
        }
    }

    private static native int jdt_thor_indirect_hint(int db, int hint);
    public static int dt_thor_indirect_hint(int db, int hint) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_indirect_hint(db, hint);
        }
    }

    private static native String jdt_thor_getauxillarydb(int db, int which_db);
    public static String dt_thor_getauxillarydb(int db, int which_db) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_getauxillarydb(db, which_db);
        }
    }

    private static native int jdt_thor_moveitem(int item, int after);
    public static int dt_thor_moveitem(int item, int after) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_moveitem(item, after);
        }
    }

    private static native String jdt_thor_raw_datafield(int dfield);
    public static String dt_thor_raw_datafield(int dfield) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_raw_datafield(dfield);
        }
    }

    private static native boolean jdt_thor_readonly(int db);
    public static boolean dt_thor_readonly(int db) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_readonly(db);
        }
    }

    private static native int jdt_thor_server(String host, String service, String user, String passwd, int[] isnew);
    public static int dt_thor_server(String host, String service, String user, String passwd, int[] isnew) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_server(host, service, user, passwd, isnew);
        }
    }

    private static native boolean jdt_thor_setauxillarydb(int db, int which_db, String path);
    public static boolean dt_thor_setauxillarydb(int db, int which_db, String path) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_setauxillarydb(db, which_db, path);
        }
    }

    private static native boolean jdt_thor_setreadonly(int db, String password, boolean readonly);
    public static boolean dt_thor_setreadonly(int db, String password, boolean readonly) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_setreadonly(db, password, readonly);
        }
    }

    private static native boolean jdt_thor_settdtlocking(int db, String password, boolean tdtlocking);
    public static boolean dt_thor_settdtlocking(int db, String password, boolean tdtlocking) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_settdtlocking(db, password, tdtlocking);
        }
    }

    private static native int jdt_thor_str2tdt(int db, String str, int merge);
    public static int dt_thor_str2tdt(int db, String str, int merge) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_str2tdt(db, str, merge);
        }
    }

    private static native String jdt_thor_tdt2str(int tdt, int exp);
    public static String dt_thor_tdt2str(int tdt, int exp) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_tdt2str(tdt, exp);
        }
    }

    private static native boolean jdt_thor_tdtlocking(int db);
    public static boolean dt_thor_tdtlocking(int db) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_tdtlocking(db);
        }
    }

    private static native int jdt_thor_tdtget(int parenth, int dtype, String id, int writeable, int[] pnew);
    public static int dt_thor_tdtget(int parenth, int dtype, String id, int writeable, int[] pnew) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_tdtget(parenth, dtype, id, writeable, pnew);
        }
    }

    private static native int jdt_thor_tdtget_raw(int db, String tag, String id, boolean writeable);
    public static int dt_thor_tdtget_raw(int db, String tag, String id, boolean writeable) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_tdtget_raw(db, tag, id, writeable);
        }
    }

    private static native String jdt_thor_tdtlockedby(int dtype, String id);
    public static String dt_thor_tdtlockedby(int dtype, String id) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_tdtlockedby(dtype, id);
        }
    }

    private static native int jdt_thor_tdtmerge(int tdt1, int tdt2);
    public static int dt_thor_tdtmerge(int tdt1, int tdt2) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_tdtmerge(tdt1, tdt2);
        }
    }

    private static native int jdt_thor_tdtremove(int tdt);
    public static int dt_thor_tdtremove(int tdt) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_tdtremove(tdt);
        }
    }

    private static native int jdt_thor_tdtremove_raw(int db, String tag, String id);
    public static int dt_thor_tdtremove_raw(int db, String tag, String id) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_tdtremove_raw(db, tag, id);
        }
    }

    private static native int jdt_thor_tdtput(int tdt, int how);
    public static int dt_thor_tdtput(int tdt, int how) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_tdtput(tdt, how);
        }
    }

    private static native int jdt_thor_tdtput_raw(int db, String tdtstr, int how);
    public static int dt_thor_tdtput_raw(int db, String tdtstr, int how) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_tdtput_raw(db, tdtstr, how);
        }
    }

    private static native int jdt_thor_tdtrevise(int tdt);
    public static int dt_thor_tdtrevise(int tdt) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_tdtrevise(tdt);
        }
    }

    private static native int jdt_thor_xrefget(int db, int dtype, String id, int[] perror);
    public static int dt_thor_xrefget(int db, int dtype, String id, int[] perror) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_xrefget(db, dtype, id, perror);
        }
    }

    private static native int jdt_thor_connect(String host, String service, String userid, String password);
    public static int dt_thor_connect(String host, String service, String userid, String password) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_connect(host, service, userid, password);
        }
    }

    private static native int jdt_thor_add_directory(int server, String passwd, String dir);
    public static int dt_thor_add_directory(int server, String passwd, String dir) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_add_directory(server, passwd, dir);
        }
    }

    private static native String jdt_thor_list_directories(int sh);
    public static String dt_thor_list_directories(int sh) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_list_directories(sh);
        }
    }

    private static native int jdt_thor_open(int server, String path, String perm, String passwd);
    public static int dt_thor_open(int server, String path, String perm, String passwd) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_open(server, path, perm, passwd);
        }
    }

    private static native String jdt_thor_list_databases(int server);
    public static String dt_thor_list_databases(int server) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_list_databases(server);
        }
    }

    private static native int jdt_thor_set_dtypes_db(int db, String path);
    public static int dt_thor_set_dtypes_db(int db, String path) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_set_dtypes_db(db, path);
        }
    }

    private static native int jdt_thor_set_indir_db(int db, String path);
    public static int dt_thor_set_indir_db(int db, String path) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_set_indir_db(db, path);
        }
    }

    private static native String jdt_thor_dtypes_db(int db);
    public static String dt_thor_dtypes_db(int db) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_dtypes_db(db);
        }
    }

    private static native String jdt_thor_indir_db(int db);
    public static String dt_thor_indir_db(int db) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_indir_db(db);
        }
    }

    private static native int jdt_thor_create(int server, String path, int d, int x, int nd, int nx);
    public static int dt_thor_create(int server, String path, int d, int x, int nd, int nx) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_create(server, path, d, x, nd, nx);
        }
    }

    private static native int jdt_thor_tdtdelete(int tdt);
    public static int dt_thor_tdtdelete(int tdt) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_tdtdelete(tdt);
        }
    }

    private static native int jdt_thor_tdtputforced(int tdt, int merge);
    public static int dt_thor_tdtputforced(int tdt, int merge) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_tdtputforced(tdt, merge);
        }
    }

    private static native int jdt_thor_tdtputraw(int db, String str);
    public static int dt_thor_tdtputraw(int db, String str) {
        synchronized(Smiles.LockObject) {
            return jdt_thor_tdtputraw(db, str);
        }
    }

    /* End of functions */

    // Constants

    public static final int     DT_THOR_INCLUDED       = 1;
    public static final String  DX_THOR_USER           = "thor";
    public static final String  DX_INFO_USER           = "thorinfo";
    public static final int     DX_THOR_FIRSTONLY      = 0;
    public static final int     DX_THOR_FINDALL        = 1;
    public static final int     DX_THOR_CACHE_OFF      = 0x0000;
    public static final int     DX_THOR_CACHE_WRITETHRU = 0x0001;
    public static final int     DX_THOR_CACHE_READWRITE = 0x0002;
    public static final int     DX_THOR_CACHE_WRITETHRU_ALL = 0x0003;
    public static final int     DX_THOR_CACHE_READWRITE_ALL = 0x0004;
    public static final int     DX_THOR_CACHE_DATA_AND_XREFS = 0x0000;
    public static final int     DX_THOR_CACHE_DATA_ONLY = 0x0100;
    public static final int     DX_THOR_CACHE_XREFS_ONLY = 0x0200;
    public static final int     DX_THOR_CACHE_NEVER    = 0;
    public static final int     DX_THOR_CACHE_ON_REQUEST = 1;
    public static final int     DX_THOR_CACHE_ALWAYS   = 2;
    public static final int     DX_THOR_CACHE_OK       = DX_THOR_CACHE_ON_REQUEST;
    public static final int     DX_THOR_INDIRECT_GETONE = 0;
    public static final int     DX_THOR_INDIRECT_GETALL = 1;
    public static final int     DX_THOR_DATATYPESDB    = 0;
    public static final int     DX_THOR_INDIRECTDB     = 1;
    public static final int     DX_THOR_MONOMERDB      = 2;
    public static final int     DX_MESSAGE_NONE        = 0;
    public static final int     DX_MESSAGE_NOW         = 1;
    public static final int     DX_MESSAGE_RECORD      = 2;
    public static final int     DX_MESSAGE_FILE        = 3;
    public static final int     DX_THOR_WRITE          = 0;
    public static final int     DX_THOR_WRITE_MERGE    = 1;
    public static final int     DX_THOR_OVERWRITE      = 2;
    public static final int     DX_THOR_MERGE          = 3;
    public static final int     DX_THOR_WRITE_KEEPLOCK = 4;
    public static final int     DX_THOR_WRITE_MERGE_KEEPLOCK = 5;
    public static final int     DX_THOR_OVERWRITE_KEEPLOCK = 6;
    public static final int     DX_THOR_UNLOCK         = 7;
    public static final int     DX_THOR_ROLLBACK       = 8;
    
    // end of constants

    static { System.loadLibrary("dj");     }

    /////////////// END
}
