    /**********************************************************************
    * This source code is public domain, and may be freely distributed,   *
    * modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO    *
    * WARRANTY OF ANY KIND.                                               *
    **********************************************************************/

#include <stdio.h>
#include <string.h>
#include <jni.h>
#include <dt_smiles.h>
#include <dt_http.h>
#include "djutils.h"
#include "djHttp.h"

JNIEXPORT jint JNICALL Java_com_daylight_Http_jdt_1alloc_1http_1server (
    JNIEnv *env, jclass cls, jint port) {
    return dt_alloc_http_server(port);
}

JNIEXPORT jint JNICALL Java_com_daylight_Http_jdt_1http_1get (
    JNIEnv *env, jclass cls, jint http) {
    return dt_http_get(http);
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Http_jdt_1http_1put (
    JNIEnv *env, jclass cls, jint transfer) {
    return dt_http_put(transfer) ? JNI_TRUE : JNI_FALSE;
}


