//  /**********************************************************************
//  * This source code is public domain, and may be freely distributed,   *
//  * modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO    *
//  * WARRANTY OF ANY KIND.                                               *
//  **********************************************************************/

import java.io.*;
import com.daylight.Smiles;

class string extends Smiles {
    public static void main(String[] args) throws IOException {
	BufferedReader in = new BufferedReader
	    (new InputStreamReader(System.in));
        PrintWriter out = new PrintWriter(System.out, true);
        String input = new String("");;
        String pname = new String("pname");;
	int object;
	String value;

	// arguments
	if (0 < args.length) {
	    // help
	    if (args[0].startsWith("-h")) {
		System.err.println("Usage: java " +
				   new string().getClass().getName() +
				   " < input.txt");
		System.exit(0);
	    }
	}

	// allocate object
	if (NULL_OB == (object = Smiles.dt_alloc_string(""))) {
	    System.err.println("ERROR: unable to allocate string");
	    System.exit(1);
	}

	// loop over input (read text)
        while (null != (input=in.readLine())) {
	    // set string
	    if (false == Smiles.dt_setstring(object, pname, input)) {
		System.err.println("ERROR: unable to set string ("
				   + input + ")");
		continue;
	    }

	    // get string
	    if (null == (value = Smiles.dt_string(object, pname))) {
		System.err.println("ERROR: unable to retrieve string ("
				   + input + ")");
		continue;
	    }

	    // show result
	    out.print(input + " -> " + value);

	    // set & get string value
	    if (false == Smiles.dt_appendstring(object, pname, "-foobar")) {
		System.err.println("ERROR: unable to append string ");
		continue;
	    }
	    if (null == (value = Smiles.dt_string(object, pname))) {
		System.err.println("ERROR: unable to get string");
		continue;
	    }

	    // show result
	    out.println(" -> " + value);

	    // voluntarily relinquish processor
	    Thread.yield();
	}

	// deallocate
	Smiles.dt_dealloc(object);

	// close I/O
        out.close();
        in.close();
    }
}
