package com.daylight;

import com.daylight.Smiles;
public class Depict {

    /* functions */
    private static native int jdt_alloc_conformation(int ob);
    public static int dt_alloc_conformation(int ob) {
	synchronized(Smiles.LockObject)
	    { return jdt_alloc_conformation(ob); }
    }

    private static native int jdt_alloc_depiction(int ob);
    public static int dt_alloc_depiction(int ob) {
	synchronized(Smiles.LockObject)
	    { return jdt_alloc_depiction(ob); }
    }

    private static native int jdt_bondstyle(int ob, int ah, int bh);
    public static int dt_bondstyle(int ob, int ah, int bh) {
	synchronized(Smiles.LockObject)
	    { return jdt_bondstyle(ob, ah, bh); }
    }

   private static native boolean jdt_calcxy(int ob);
    public static boolean dt_calcxy(int ob) {
	synchronized(Smiles.LockObject)
	    { return jdt_calcxy(ob); }
    }

    private static native boolean jdt_compressed(int ob);
    public static boolean dt_compressed(int ob) {
	synchronized(Smiles.LockObject)
	    { return jdt_compressed(ob); }
    }

    private static native boolean jdt_depict(int ob);
    public static boolean dt_depict(int ob) {
	synchronized(Smiles.LockObject)
	    { return jdt_depict(ob); }
    }

    private static native boolean jdt_frame(int ob);
    public static boolean dt_frame(int ob) {
	synchronized(Smiles.LockObject)
	    { return jdt_frame(ob); }
    }

    private static native int jdt_framega(int ob);
    public static int dt_framega(int ob) {
	synchronized(Smiles.LockObject)
	    { return jdt_framega(ob); }
    }

    private static native int jdt_ga(int ob, int ob2);
    public static int dt_ga(int ob, int ob2) {
	synchronized(Smiles.LockObject)
	    { return jdt_ga(ob, ob2); }
    }

    private static native boolean jdt_getcoord(int ob, int ah, float[] x, float[] y, float[] z);
    public static boolean dt_getcoord(int ob, int ah, float[] x, float[] y, float[] z) {
	synchronized(Smiles.LockObject)
	    { return jdt_getcoord(ob, ah, x, y, z); }
    }

    private static native boolean jdt_isomeric(int ob);
    public static boolean dt_isomeric(int ob) {
	synchronized(Smiles.LockObject)
	    { return jdt_isomeric(ob); }
    }

    private static native String jdt_label1(int ob, int ob2);
    public static String dt_label1(int ob, int ob2) {
	synchronized(Smiles.LockObject)
	    { return jdt_label1(ob, ob2); }
    }

    private static native int jdt_label1ga(int ob, int ob2);
    public static int dt_label1ga(int ob, int ob2) {
	synchronized(Smiles.LockObject)
	    { return jdt_label1ga(ob, ob2); }
    }

    private static native String jdt_label2(int ob, int ob2);
    public static String dt_label2(int ob, int ob2) {
	synchronized(Smiles.LockObject)
	    { return jdt_label2(ob, ob2); }
    }

    private static native int jdt_label2ga(int ob, int ob2);
    public static int dt_label2ga(int ob, int ob2) {
	synchronized(Smiles.LockObject)
	    { return jdt_label2ga(ob, ob2); }
    }

    private static native int jdt_orient(int ob);
    public static int dt_orient(int ob) {
	synchronized(Smiles.LockObject)
	    { return jdt_orient(ob); }
    }

    private static native boolean jdt_project(int ob, int conf);
    public static boolean dt_project(int ob, int conf) {
	synchronized(Smiles.LockObject)
	    { return jdt_project(ob, conf); }
    }

    private static native boolean jdt_rotate(int ob, float x, float y, float z, float theta);
    public static boolean dt_rotate(int ob, float x, float y, float z, float theta) {
	synchronized(Smiles.LockObject)
	    { return jdt_rotate(ob, x, y, z, theta); }
    }

    private static native boolean jdt_scale(int ob, float cx, float cy, float cz);
    public static boolean dt_scale(int ob, float cx, float cy, float cz) {
	synchronized(Smiles.LockObject)
	    { return jdt_scale(ob, cx, cy, cz); }
    }

    private static native boolean jdt_schematic(int ob);
    public static boolean dt_schematic(int ob) {
	synchronized(Smiles.LockObject)
	    { return jdt_schematic(ob); }
    }

    private static native boolean jdt_setbondstyles(int ob);
    public static boolean dt_setbondstyles(int ob) {
	synchronized(Smiles.LockObject)
	    { return jdt_setbondstyles(ob); }
    }

    private static native boolean jdt_setcompressed(int ob, boolean v);
    public static boolean dt_setcompressed(int ob, boolean v) {
	synchronized(Smiles.LockObject)
	    { return jdt_setcompressed(ob, v); }
    }

    private static native boolean jdt_setcoord(int ob, int ah, float x, float y, float z);
    public static boolean dt_setcoord(int ob, int ah, float x, float y, float z) {
	synchronized(Smiles.LockObject)
	    { return jdt_setcoord(ob, ah, x, y, z); }
    }

    private static native boolean jdt_setframe(int ob, boolean v);
    public static boolean dt_setframe(int ob, boolean v) {
	synchronized(Smiles.LockObject)
	    { return jdt_setframe(ob, v); }
    }

    private static native boolean jdt_setframega(int ob, int ga);
    public static boolean dt_setframega(int ob, int ga) {
	synchronized(Smiles.LockObject)
	    { return jdt_setframega(ob, ga); }
    }

    private static native boolean jdt_setga(int ob, int ob2, int v);
    public static boolean dt_setga(int ob, int ob2, int v) {
	synchronized(Smiles.LockObject)
	    { return jdt_setga(ob, ob2, v); }
    }

    private static native boolean jdt_setisomeric(int ob, int v);
    public static boolean dt_setisomeric(int ob, int v) {
	synchronized(Smiles.LockObject)
	    { return jdt_setisomeric(ob, v); }
    }

    private static native boolean jdt_setlabel1(int ob, int ob2, String lab);
    public static boolean dt_setlabel1(int ob, int ob2, String lab) {
	synchronized(Smiles.LockObject)
	    { return jdt_setlabel1(ob, ob2, lab); }
    }

    private static native boolean jdt_setlabel2(int ob, int ob2, String lab);
    public static boolean dt_setlabel2(int ob, int ob2, String lab) {
	synchronized(Smiles.LockObject)
	    { return jdt_setlabel2(ob, ob2, lab); }
    }

    private static native boolean jdt_setlabel1ga(int ob, int ob2, int ga);
    public static boolean dt_setlabel1ga(int ob, int ob2, int ga) {
	synchronized(Smiles.LockObject)
	    { return jdt_setlabel1ga(ob, ob2, ga); }
    }

    private static native boolean jdt_setlabel2ga(int ob, int ob2, int ga);
    public static boolean dt_setlabel2ga(int ob, int ob2, int ga) {
	synchronized(Smiles.LockObject)
	    { return jdt_setlabel2ga(ob, ob2, ga); }
    }

    private static native boolean jdt_setorient(int ob, int v);
    public static boolean dt_setorient(int ob, int v) {
	synchronized(Smiles.LockObject)
	    { return jdt_setorient(ob, v); }
    }

    private static native boolean jdt_setschematic(int ob, int v);
    public static boolean dt_setschematic(int ob, int v) {
	synchronized(Smiles.LockObject)
	    { return jdt_setschematic(ob, v); }
    }

    private static native boolean jdt_translate(int ob, float x, float y, float z);
    public static boolean dt_translate(int ob, float x, float y, float z) {
	synchronized(Smiles.LockObject)
	    { return jdt_translate(ob, x, y, z); }
    }

    private static native boolean jdt_zerocoord(int ob);
    public static boolean dt_zerocoord(int ob) {
	synchronized(Smiles.LockObject)
	    { return jdt_zerocoord(ob); }
    }

    /* End of functions */

    // Constants

    //======================================================================
    //  Depiction-orientation attributes.
    //====================================================================*/

    public static final int DX_ORIENT_NONE    = (0x000);
    public static final int DX_ORIENT_AUTO    = (0x001);
    public static final int DX_ORIENT_WILD    = (0x002);

    //======================================================================
    // Bond-rendition attributes.
    //====================================================================*/

    public static final int DX_EDGE_SIMPLE    = (0x000);
    public static final int DX_EDGE_TEE       = (0x001);
    public static final int DX_EDGE_TEE_IN    = (0x002);
    public static final int DX_EDGE_TEE_OUT   = (0x004);
    public static final int DX_EDGE_TRI       = (0x008);
    public static final int DX_EDGE_TRI_IN    = (0x010);
    public static final int DX_EDGE_TRI_OUT   = (0x020);
    public static final int DX_EDGE_HASH      = (0x040);
    public static final int DX_EDGE_DATIVE    = (0x080);

    public static final int DX_EDGE_IS_TEE_IN   = (DX_EDGE_TEE | DX_EDGE_TEE_IN);
    public static final int DX_EDGE_IS_TEE_OUT  = (DX_EDGE_TEE | DX_EDGE_TEE_OUT);
    public static final int DX_EDGE_IS_TRI_IN   = (DX_EDGE_TRI | DX_EDGE_TRI_IN);
    public static final int DX_EDGE_IS_TRI_OUT  = (DX_EDGE_TRI | DX_EDGE_TRI_OUT);
    public static final int DX_EDGE_IS_DIAMOND  = (DX_EDGE_TRI | DX_EDGE_TRI_IN  | DX_EDGE_TRI_OUT);
    public static final int DX_EDGE_IS_BOWTIE   = (DX_EDGE_TRI);
    public static final int DX_EDGE_IS_HASH_IN  = (DX_EDGE_TRI | DX_EDGE_TRI_IN  | DX_EDGE_HASH);
    public static final int DX_EDGE_IS_HASH_OUT = (DX_EDGE_TRI | DX_EDGE_TRI_OUT | DX_EDGE_HASH);
    public static final int DX_EDGE_IS_DATIVE   = (DX_EDGE_DATIVE);
    
    // end of constants

    static { System.loadLibrary("dj"); }

    /////////////// END
}
