package com.daylight;

import com.daylight.Smiles;
public class Progob {

    /* functions */
    private static native int jdt_alloc_program(int ob);
    public static int dt_alloc_program(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_alloc_program(ob);
	}
    }

    private static native int jdt_welcome(int prog);
    public static int dt_welcome(int prog) {
        synchronized(Smiles.LockObject) {
            return jdt_welcome(prog);
	}
    }

    private static native int jdt_converse(int prog, int msgob);
    public static int dt_converse(int prog, int msgob) {
        synchronized(Smiles.LockObject) {
            return jdt_converse(prog, msgob);
	}
    }

    private static native int jdt_delimiter(int prog);
    public static int dt_delimiter(int prog) {
        synchronized(Smiles.LockObject) {
            return jdt_delimiter(prog);
	}
    }

    private static native boolean jdt_setdelimiter(int prog, int value);
    public static boolean dt_setdelimiter(int prog, int value) {
        synchronized(Smiles.LockObject) {
            return jdt_setdelimiter(prog, value);
	}
    }

    /* End of functions */

    // Constants

    public static final int     DX_PT_NONE             = 0;
    public static final int     DX_PT_CR               = 1;
    public static final String  DX_PT_MSGLIST          = "Qwerty: Say MSGLIST.";
    public static final String  DX_PT_HELP             = "Qwerty: Say HELP.";
    public static final String  DX_PT_PROGRAM          = "Qwerty: Say PROGRAM.";
    public static final String  DX_PT_VERSION          = "Qwerty: Say VERSION.";
    public static final String  DX_PT_NOTICE           = "Qwerty: Say NOTICE.";
    public static final String  DX_PT_EOM              = "Qwerty: Over.";
    public static final String  DX_PT_EOT              = "Qwerty: Over and out.";

    // end of constants

    static { System.loadLibrary("dj"); }

    /////////////// END
}
