package com.daylight;

public class Smiles {

    /* functions */
    private static native boolean jdt_abort(int ob);
    public static boolean dt_abort(int ob) {
	synchronized(Smiles.LockObject) {
	   return jdt_abort(ob);
	}
    }

    private static native int jdt_add(int ob, int elt);
    public static int dt_add(int ob, int elt) {
	synchronized(Smiles.LockObject) {
	    return jdt_add(ob, elt);
	}
    }

    private static native int jdt_addatom(int ob, int atno, int hct);
    public static int dt_addatom(int ob, int atno, int hct) {
	synchronized(Smiles.LockObject) {
	    return jdt_addatom(ob, atno, hct);
	}
    }

    private static native int jdt_addbond(int a0, int a1, int btyp);
    public static int dt_addbond(int a0, int a1, int btyp) {
	synchronized(Smiles.LockObject) {
	    return jdt_addbond(a0, a1, btyp);
	}
    }

    private static native int jdt_addcomponent(int rxn, int mol, int role);
    public static int dt_addcomponent(int rxn, int mol, int role) {
	synchronized(Smiles.LockObject) {
	    return jdt_addcomponent(rxn, mol, role);
	}
    }

    private static native int jdt_adjunct(int ob);
    public static int dt_adjunct(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_adjunct(ob);
        }
    }

    private static native int jdt_alloc_integer();
    public static int dt_alloc_integer() {
        synchronized(Smiles.LockObject) {
            return jdt_alloc_integer();
        }
    }

    private static native int jdt_alloc_mol();
    public static int dt_alloc_mol() {
        synchronized(Smiles.LockObject) {
            return jdt_alloc_mol();
        }
    }

    private static native int jdt_alloc_path(int mh);
    public static int dt_alloc_path(int mh) {
        synchronized(Smiles.LockObject) {
            return jdt_alloc_path(mh);
        }
    }

    private static native int jdt_alloc_reaction();
    public static int dt_alloc_reaction() {
        synchronized(Smiles.LockObject) {
            return jdt_alloc_reaction();
        }
    }

    private static native int jdt_alloc_real();
    public static int dt_alloc_real() {
        synchronized(Smiles.LockObject) {
            return jdt_alloc_real();
        }
    }

    private static native int jdt_alloc_seq();
    public static int dt_alloc_seq() {
        synchronized(Smiles.LockObject) {
            return jdt_alloc_seq();
        }
    }

    private static native int jdt_alloc_string(String s);
    public static int dt_alloc_string(String s) {
        synchronized(Smiles.LockObject) {
            return jdt_alloc_string(s);
        }
    }

    private static native int jdt_alloc_substruct(int mh);
    public static int dt_alloc_substruct(int mh) {
        synchronized(Smiles.LockObject) {
            return jdt_alloc_substruct(mh);
        }
    }

    private static native int jdt_append(int ob, int elt);
    public static int dt_append(int ob, int elt) {
        synchronized(Smiles.LockObject) {
            return jdt_append(ob, elt);
        }
    }

    private static native boolean jdt_appendstring(int ob, String name, String value);
    public static boolean dt_appendstring(int ob, String name, String value) {
        synchronized(Smiles.LockObject) {
            return jdt_appendstring(ob, name, value);
        }
    }

    private static native boolean jdt_appendstringvalue(int ob, byte[] value);
    public static boolean dt_appendstringvalue(int ob, byte[] value) {
        synchronized(Smiles.LockObject) {
            return jdt_appendstringvalue(ob, value);
        }
    }

    private static native int jdt_arborder(int ob);
    public static int dt_arborder(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_arborder(ob);
        }
    }

    private static native String jdt_arbsmiles(int ob, boolean iso);
    public static String dt_arbsmiles(int ob, boolean iso) {
        synchronized(Smiles.LockObject) {
            return jdt_arbsmiles(ob, iso);
        }
    }

    private static native int jdt_arbstream(int mh, int type, boolean iso, boolean addh);
    public static int dt_arbstream(int mh, int type, boolean iso, boolean addh) {
        synchronized(Smiles.LockObject) {
            return jdt_arbstream(mh, type, iso, addh);
        }
    }

    private static native boolean jdt_aromatic(int ob);
    public static boolean dt_aromatic(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_aromatic(ob);
        }
    }

    private static native int jdt_ascii2binary(String ascii);
    public static int dt_ascii2binary(String ascii) {
        synchronized(Smiles.LockObject) {
            return jdt_ascii2binary(ascii);
        }
    }

    private static native boolean jdt_atend(int ob);
    public static boolean dt_atend(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_atend(ob);
        }
    }

    private static native boolean jdt_atstart(int ob);
    public static boolean dt_atstart(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_atstart(ob);
        }
    }

    private static native int jdt_base(int ob);
    public static int dt_base(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_base(ob);
        }
    }

    private static native int jdt_binary2ascii(byte[] bin);
    public static int dt_binary2ascii(byte[] bin) {
        synchronized(Smiles.LockObject) {
            return jdt_binary2ascii(bin);
        }
    }

    private static native int jdt_binary2asciilen(String bin);
    public static int dt_binary2asciilen(String bin) {
        synchronized(Smiles.LockObject) {
            return jdt_binary2asciilen(bin);
        }
    }

    private static native int jdt_bond(int a0, int a1);
    public static int dt_bond(int a0, int a1) {
        synchronized(Smiles.LockObject) {
            return jdt_bond(a0, a1);
        }
    }

    private static native int jdt_bondorder(int ob);
    public static int dt_bondorder(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_bondorder(ob);
        }
    }

    private static native int jdt_bondtype(int ob);
    public static int dt_bondtype(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_bondtype(ob);
        }
    }

    private static native boolean jdt_boolean(int ob, String name);
    public static boolean dt_boolean(int ob, String name) {
        synchronized(Smiles.LockObject) {
            return jdt_boolean(ob, name);
        }
    }

    private static native String jdt_briefname(int ob);
    public static String dt_briefname(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_briefname(ob);
        }
    }

    private static native int jdt_canatom_stream(int mh, boolean iso, boolean addh);
    public static int dt_canatom_stream(int mh, boolean iso, boolean addh) {
        synchronized(Smiles.LockObject) {
            return jdt_canatom_stream(mh, iso, addh);
        }
    }

    private static native int jdt_canbond_stream(int mh, boolean iso, boolean addh);
    public static int dt_canbond_stream(int mh, boolean iso, boolean addh) {
        synchronized(Smiles.LockObject) {
            return jdt_canbond_stream(mh, iso, addh);
        }
    }

    private static native int jdt_cansmi_stream(int mh, boolean iso);

    public static int dt_cansmi_stream(int mh, boolean iso) {
        synchronized(Smiles.LockObject) {
            return jdt_cansmi_stream(mh, iso);
        }
    }

    private static native int jdt_canstream(int mh, int type, boolean iso, boolean addh);
    public static int dt_canstream(int mh, int type, boolean iso, boolean addh) {
        synchronized(Smiles.LockObject) {
            return jdt_canstream(mh, type, iso, addh);
        }
    }

    private static native String jdt_cansmiles(int ob, boolean iso);
    public static String dt_cansmiles(int ob, boolean iso) {
        synchronized(Smiles.LockObject) {
            return jdt_cansmiles(ob, iso);
        }
    }

    private static native int jdt_charge(int ob);
    public static int dt_charge(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_charge(ob);
        }
    }

    private static native int jdt_check_license(int check_what, String product);
    public static int dt_check_license(int check_what, String product) {
        synchronized(Smiles.LockObject) {
            return jdt_check_license(check_what, product);
        }
    }

    private static native int jdt_chiclass(int chival);
    public static int dt_chiclass(int chival) {
        synchronized(Smiles.LockObject) {
            return jdt_chiclass(chival);
        }
    }

     private static native int jdt_chiorder(int chival);
     public static int dt_chiorder(int chival) {
        synchronized(Smiles.LockObject) {
            return jdt_chiorder(chival);
        }
     }

    private static native int jdt_chiperm(int bseqh, int bh, int chival);
    public static int dt_chiperm(int bseqh, int bh, int chival) {
        synchronized(Smiles.LockObject) {
            return jdt_chiperm(bseqh, bh, chival);
        }
     }

    private static native int jdt_chiseq(int a, int v);
    public static int dt_chiseq(int a, int v) {
        synchronized(Smiles.LockObject) {
            return jdt_chiseq(a, v);
        }
     }

    private static native int jdt_chival(int a, int s);
    public static int dt_chival(int a, int s) {
        synchronized(Smiles.LockObject) {
            return jdt_chival(a, s);
        }
     }

    private static native int jdt_continue(int s, int[] return_status);
    public static int dt_continue(int s, int[] return_status) {
        synchronized(Smiles.LockObject) {
            return jdt_continue(s, return_status);
        }
     }

    private static native int jdt_copy(int ob);
    public static int dt_copy(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_copy(ob);
        }
     }

    private static native int jdt_count(int ob, int typ);
    public static int dt_count(int ob, int typ) {
        synchronized(Smiles.LockObject) {
            return jdt_count(ob, typ);
        }
     }

    private static native int jdt_database(int ob);
    public static int dt_database(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_database(ob);
        }
     }

    private static native int jdt_datatype(int ob);
    public static int dt_datatype(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_datatype(ob);
        }
     }

    private static native int jdt_dbo(int ob, int b0, int b1);
    public static int dt_dbo(int ob, int b0, int b1) {
        synchronized(Smiles.LockObject) {
            return jdt_dbo(ob, b0, b1);
        }
     }

    private static native boolean jdt_define(int ob, String symbol, String name);
    public static boolean dt_define(int ob, String symbol, String name) {
        synchronized(Smiles.LockObject) {
            return jdt_define(ob, symbol, name);
        }
     }

    private static native boolean jdt_dealloc(int ob);
    public static boolean dt_dealloc(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_dealloc(ob);
        }
     }

    private static native boolean jdt_delete(int ob);
    public static boolean dt_delete(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_delete(ob);
        }
     }

    private static native String jdt_description(int ob);
    public static String dt_description(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_description(ob);
        }
     }

    private static native boolean jdt_dfnorm(int ob, int norm);
    public static boolean dt_dfnorm(int ob, int norm) {
        synchronized(Smiles.LockObject) {
            return jdt_dfnorm(ob, norm);
        }
     }

    private static native String jdt_dfnormdata(int ob, int norm);
    public static String dt_dfnormdata(int ob, int norm) {
        synchronized(Smiles.LockObject) {
            return jdt_dfnormdata(ob, norm);
        }
     }

    private static native int jdt_done_when(int ob);
    public static int dt_done_when(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_done_when(ob);
        }
     }

    private static native void jdt_errorclear();
    public static void dt_errorclear() {
        synchronized(Smiles.LockObject) {
	   jdt_errorclear();
        }
     }

    private static native int jdt_errorworst();
    public static int dt_errorworst() {
        synchronized(Smiles.LockObject) {
            return jdt_errorworst();
        }
     }

    private static native int jdt_errors(int lev);
    public static int dt_errors(int lev) {
        synchronized(Smiles.LockObject) {
            return jdt_errors(lev);
        }
     }

    private static native boolean jdt_errorsave(String func, int lev, String msg);
    public static boolean dt_errorsave(String func, int lev, String msg) {
        synchronized(Smiles.LockObject) {
            return jdt_errorsave(func, lev, msg);
        }
     }

    private static native int jdt_evict(int ob, String password, String username, int message, boolean do_eviction);
    public static int dt_evict(int ob, String password, String username, int message, boolean do_eviction) {
        synchronized(Smiles.LockObject) {
            return jdt_evict(ob, password, username, message, do_eviction);
        }
     }

    private static native boolean jdt_exists(int server, String name);
    public static boolean dt_exists(int server, String name) {
        synchronized(Smiles.LockObject) {
            return jdt_exists(server, name);
        }
     }

    private static native int jdt_fieldtype(int ob);

    public static int dt_fieldtype(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_fieldtype(ob);
        }
     }

    private static native int jdt_getdatabases(int server);
    public static int dt_getdatabases(int server) {
        synchronized(Smiles.LockObject) {
            return jdt_getdatabases(server);
        }
     }

    private static native int jdt_getdatatype(int ob, String tag);
    public static int dt_getdatatype(int ob, String tag) {
        synchronized(Smiles.LockObject) {
            return jdt_getdatatype(ob, tag);
        }
     }

    private static native int jdt_getmap(int atom);
    public static int dt_getmap(int atom) {
        synchronized(Smiles.LockObject) {
            return jdt_getmap(atom);
        }
     }

    private static native int jdt_getpasswords(int server);
    public static int dt_getpasswords(int server) {
        synchronized(Smiles.LockObject) {
            return jdt_getpasswords(server);
        }
     }

    private static native int jdt_getrole(int ob1, int ob2);
    public static int dt_getrole(int ob1, int ob2) {
        synchronized(Smiles.LockObject) {
            return jdt_getrole(ob1, ob2);
        }
     }

    private static native int jdt_getsearchpath(int server);
    public static int dt_getsearchpath(int server) {
        synchronized(Smiles.LockObject) {
            return jdt_getsearchpath(server);
        }
     }

    private static native int jdt_getusers(int server);
    public static int dt_getusers(int server) {
        synchronized(Smiles.LockObject) {
            return jdt_getusers(server);
        }
     }

    private static native int jdt_handle(int ob, String name);
    public static int dt_handle(int ob, String name) {
        synchronized(Smiles.LockObject) {
            return jdt_handle(ob, name);
        }
     }

    private static native int jdt_hcount(int ob);
    public static int dt_hcount(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_hcount(ob);
        }
     }

    private static native boolean jdt_hold(int ob, String pw);
    public static boolean dt_hold(int ob, String pw) {
        synchronized(Smiles.LockObject) {
            return jdt_hold(ob, pw);
        }
     }

    private static native int jdt_imp_hcount(int ob);
    public static int dt_imp_hcount(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_imp_hcount(ob);
        }
     }

    private static native String jdt_info(int ob, String req);
    public static String dt_info(int ob, String req) {
        synchronized(Smiles.LockObject) {
            return jdt_info(ob, req);
        }
     }

    private static native int jdt_insert(int ob, int elt);
    public static int dt_insert(int ob, int elt) {
        synchronized(Smiles.LockObject) {
            return jdt_insert(ob, elt);
        }
     }

    private static native int jdt_integer(int ob, String name);

    public static int dt_integer(int ob, String name) {
        synchronized(Smiles.LockObject) {
            return jdt_integer(ob, name);
        }
     }

    private static native int jdt_integervalue(int ob);
    public static int dt_integervalue(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_integervalue(ob);
        }
     }

    private static native boolean jdt_invalid(int ob);
    public static boolean dt_invalid(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_invalid(ob);
        }
     }

    private static native boolean jdt_isheld(int ob);
    public static boolean dt_isheld(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_isheld(ob);
        }
     }

    private static native boolean jdt_isopen(int server, String name);
    public static boolean dt_isopen(int server, String name) {
        synchronized(Smiles.LockObject) {
            return jdt_isopen(server, name);
        }
     }

    private static native boolean jdt_ispublic(int server, String name);
    public static boolean dt_ispublic(int server, String name) {
        synchronized(Smiles.LockObject) {
            return jdt_ispublic(server, name);
        }
     }

    private static native int jdt_isohydro();
    public static int dt_isohydro() {
        synchronized(Smiles.LockObject) {
            return jdt_isohydro();
        }
     }

    private static native boolean jdt_mapped(int a1, int a2);
    public static boolean dt_mapped(int a1, int a2) {
        synchronized(Smiles.LockObject) {
            return jdt_mapped(a1, a2);
        }
     }

    private static native boolean jdt_member(int ob, int elt);
    public static boolean dt_member(int ob, int elt) {
        synchronized(Smiles.LockObject) {
            return jdt_member(ob, elt);
        }
     }

    private static native boolean jdt_mod_is_on(int ob);
    public static boolean dt_mod_is_on(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_mod_is_on(ob);
        }
     }

    private static native boolean jdt_mod_off(int ob);
    public static boolean dt_mod_off(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_mod_off(ob);
        }
     }

    private static native boolean jdt_mod_on(int ob);
    public static boolean dt_mod_on(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_mod_on(ob);
        }
     }

    private static native int jdt_molecule(int ob);
    public static int dt_molecule(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_molecule(ob);
        }
     }

    private static native int jdt_molgraph(int ob);
    public static int dt_molgraph(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_molgraph(ob);
        }
     }

    private static native int jdt_monomertable(int ob);
    public static int dt_monomertable(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_monomertable(ob);
        }
     }

    private static native String jdt_name(int ob);
    public static String dt_name(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_name(ob);
        }
     }

    private static native int jdt_next(int ob);
    public static int dt_next(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_next(ob);
        }
     }

    private static native int jdt_number(int ob);
    public static int dt_number(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_number(ob);
        }
     }

    private static native int jdt_open(int s, String path, String perm, String pass, int[] isnew);
    public static int dt_open(int s, String path, String perm, String pass, int[] isnew) {
        synchronized(Smiles.LockObject) {
            return jdt_open(s, path, perm, pass, isnew);
        }
     }

    private static native int jdt_origsmi_stream(int mh);
    public static int dt_origsmi_stream(int mh) {
        synchronized(Smiles.LockObject) {
            return jdt_origsmi_stream(mh);
        }
     }

    private static native int jdt_origstream(int mh, int type);
    public static int dt_origstream(int mh, int type) {
        synchronized(Smiles.LockObject) {
            return jdt_origstream(mh, type);
        }
     }

    private static native int jdt_parent(int ob);
    public static int dt_parent(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_parent(ob);
        }
     }

    private static native int jdt_ping(int server, String s);
    public static int dt_ping(int server, String s) {
        synchronized(Smiles.LockObject) {
            return jdt_ping(server, s);
        }
     }

    private static native int jdt_propnames(int ob);
    public static int dt_propnames(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_propnames(ob);
        }
     }

    private static native int jdt_proptype(int ob, String name);
    public static int dt_proptype(int ob, String name) {
        synchronized(Smiles.LockObject) {
            return jdt_proptype(ob, name);
        }
     }

    private static native float jdt_real(int ob, String name);
    public static float dt_real(int ob, String name) {
        synchronized(Smiles.LockObject) {
            return jdt_real(ob, name);
        }
     }

    private static native float jdt_realvalue(int ob);
    public static float dt_realvalue(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_realvalue(ob);
        }
     }

    private static native boolean jdt_release(int ob, String pw);
    public static boolean dt_release(int ob, String pw) {
        synchronized(Smiles.LockObject) {
            return jdt_release(ob, pw);
        }
     }

    private static native boolean jdt_remove(int ob, int elt);
    public static boolean dt_remove(int ob, int elt) {
        synchronized(Smiles.LockObject) {
            return jdt_remove(ob, elt);
        }
     }

    private static native boolean jdt_reset(int ob);
    public static boolean dt_reset(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_reset(ob);
        }
     }

    private static native int jdt_seqappend(int ob, int elt);
    public static int dt_seqappend(int ob, int elt) {
        synchronized(Smiles.LockObject) {
            return jdt_seqappend(ob, elt);
        }
     }

    private static native boolean jdt_seqdelete(int ob);
    public static boolean dt_seqdelete(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_seqdelete(ob);
        }
     }

    private static native int jdt_seqinsert(int ob, int elt);
    public static int dt_seqinsert(int ob, int elt) {
        synchronized(Smiles.LockObject) {
            return jdt_seqinsert(ob, elt);
        }
     }
    private static native boolean jdt_seqsort(int ob);
    public static boolean dt_seqsort(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_seqsort(ob);
        }
     }

    private static native int jdt_server(int ob);
    public static int dt_server(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_server(ob);
        }
     }

    private static native int jdt_set_server_timeout(int resw_new);
    public static int dt_set_server_timeout(int resw_new) {
        synchronized(Smiles.LockObject) {
            return jdt_set_server_timeout(resw_new);
        }
     }

    private static native int jdt_setadjunct(int ob, int adj);
    public static int dt_setadjunct(int ob, int adj) {
        synchronized(Smiles.LockObject) {
            return jdt_setadjunct(ob, adj);
        }
     }

    private static native boolean jdt_setarborder(int ob, int val);
    public static boolean dt_setarborder(int ob, int val) {
        synchronized(Smiles.LockObject) {
            return jdt_setarborder(ob, val);
        }
     }

    private static native boolean jdt_setaromatic(int ob, boolean val);
    public static boolean dt_setaromatic(int ob, boolean val) {
        synchronized(Smiles.LockObject) {
            return jdt_setaromatic(ob, val);
        }
     }

    private static native boolean jdt_setboolean(int ob, String name, boolean value);
    public static boolean dt_setboolean(int ob, String name, boolean value) {
        synchronized(Smiles.LockObject) {
            return jdt_setboolean(ob, name, value);
        }
     }

    private static native boolean jdt_setbondorder(int ob, int val);
    public static boolean dt_setbondorder(int ob, int val) {
        synchronized(Smiles.LockObject) {
            return jdt_setbondorder(ob, val);
        }
     }

    private static native boolean jdt_setbondtype(int ob, int val);
    public static boolean dt_setbondtype(int ob, int val) {
        synchronized(Smiles.LockObject) {
            return jdt_setbondtype(ob, val);
        }
     }

    private static native boolean jdt_setcharge(int ob, int val);
    public static boolean dt_setcharge(int ob, int val) {
        synchronized(Smiles.LockObject) {
            return jdt_setcharge(ob, val);
        }
     }

    private static native boolean jdt_setchival(int a, int s, int v);
    public static boolean dt_setchival(int a, int s, int v) {
        synchronized(Smiles.LockObject) {
            return jdt_setchival(a, s, v);
        }
     }

    private static native boolean jdt_setdbo(int ob, int b0, int b1, int v);
    public static boolean dt_setdbo(int ob, int b0, int b1, int v) {
        synchronized(Smiles.LockObject) {
            return jdt_setdbo(ob, b0, b1, v);
        }
     }

    private static native boolean jdt_sethandle(int ob, String name, int value);
    public static boolean dt_sethandle(int ob, String name, int value) {
        synchronized(Smiles.LockObject) {
            return jdt_sethandle(ob, name, value);
        }
     }

    private static native boolean jdt_setimp_hcount(int ob, int val);
    public static boolean dt_setimp_hcount(int ob, int val) {
        synchronized(Smiles.LockObject) {
            return jdt_setimp_hcount(ob, val);
        }
     }

    private static native boolean jdt_setinteger(int ob, String name, int value);
    public static boolean dt_setinteger(int ob, String name, int value) {
        synchronized(Smiles.LockObject) {
            return jdt_setinteger(ob, name, value);
        }
     }

    private static native boolean jdt_setintegervalue(int ob, int value);
    public static boolean dt_setintegervalue(int ob, int value) {
        synchronized(Smiles.LockObject) {
            return jdt_setintegervalue(ob, value);
        }
     }

    private static native boolean jdt_setmap(int a1, int a2);
    public static boolean dt_setmap(int a1, int a2) {
        synchronized(Smiles.LockObject) {
            return jdt_setmap(a1, a2);
        }
     }

    private static native boolean jdt_setmessage(int ob, String password, int when, int message);
    public static boolean dt_setmessage(int ob, String password, int when, int message) {
        synchronized(Smiles.LockObject) {
            return jdt_setmessage(ob, password, when, message);
        }
     }

    private static native boolean jdt_setnumber(int ob, int val);
    public static boolean dt_setnumber(int ob, int val) {
        synchronized(Smiles.LockObject) {
            return jdt_setnumber(ob, val);
        }
     }

    private static native boolean jdt_setpassword(int ob, String what, String oldpw, String newpw);
    public static boolean dt_setpassword(int ob, String what, String oldpw, String newpw) {
        synchronized(Smiles.LockObject) {
            return jdt_setpassword(ob, what, oldpw, newpw);
        }
     }

    private static native boolean jdt_setreal(int ob, String name, float value);
    public static boolean dt_setreal(int ob, String name, float value) {
        synchronized(Smiles.LockObject) {
            return jdt_setreal(ob, name, value);
        }
     }

    private static native boolean jdt_setrealvalue(int ob, float value);
    public static boolean dt_setrealvalue(int ob, float value) {
        synchronized(Smiles.LockObject) {
            return jdt_setrealvalue(ob, value);
        }
     }

    private static native boolean jdt_setsearchpath(int server, String password, String dir, int replace);
    public static boolean dt_setsearchpath(int server, String password, String dir, int replace) {
        synchronized(Smiles.LockObject) {
            return jdt_setsearchpath(server, password, dir, replace);
        }
     }

    private static native boolean jdt_setstring(int ob, String name, String value);
    public static boolean dt_setstring(int ob, String name, String value) {
        synchronized(Smiles.LockObject) {
            return jdt_setstring(ob, name, value);
        }
     }

    private static native boolean jdt_setstringvalue(int ob, byte[] value);
    public static boolean dt_setstringvalue(int ob, byte[] value) {
        synchronized(Smiles.LockObject) {
            return jdt_setstringvalue(ob, value);
        }
     }

    private static native boolean jdt_setweight(int ob, int val);
    public static boolean dt_setweight(int ob, int val) {
        synchronized(Smiles.LockObject) {
            return jdt_setweight(ob, val);
        }
     }

    private static native int jdt_smilin(String s);
    public static int dt_smilin(String s) {
        synchronized(Smiles.LockObject) {
            return jdt_smilin(s);
        }
     }

    private static native int jdt_smilinerrors();
    public static int dt_smilinerrors() {
        synchronized(Smiles.LockObject) {
            return jdt_smilinerrors();
        }
     }

    private static native String jdt_smilinerrtext();
    public static String dt_smilinerrtext() {
        synchronized(Smiles.LockObject) {
            return jdt_smilinerrtext();
        }
     }

    private static native int jdt_stream(int ob, int typ);
    public static int dt_stream(int ob, int typ) {
        synchronized(Smiles.LockObject) {
            return jdt_stream(ob, typ);
        }
     }

    private static native String jdt_string(int ob, String name);
    public static String dt_string(int ob, String name) {
        synchronized(Smiles.LockObject) {
            return jdt_string(ob, name);
        }
     }

    private static native byte[] jdt_stringvalue(int ob);
    public static byte[] dt_stringvalue(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_stringvalue(ob);
        }
     }

    private static native String jdt_summary(int ob);
    public static String dt_summary(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_summary(ob);
        }
     }

    private static native String jdt_symbol(int ob);
    public static String dt_symbol(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_symbol(ob);
        }
     }

    private static native int jdt_symclass(int ob, boolean i);
    public static int dt_symclass(int ob, boolean i) {
        synchronized(Smiles.LockObject) {
            return jdt_symclass(ob, i);
        }
     }

    private static native int jdt_symorder(int ob, boolean i);
    public static int dt_symorder(int ob, boolean i) {
        synchronized(Smiles.LockObject) {
            return jdt_symorder(ob, i);
        }
     }

    private static native String jdt_tag(int ob);
    public static String dt_tag(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_tag(ob);
        }
     }

    private static native boolean jdt_toend(int ob);
    public static boolean dt_toend(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_toend(ob);
        }
     }

    private static native int jdt_type(int ob);
    public static int dt_type(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_type(ob);
        }
     }

    private static native String jdt_typename(int ob);
    public static String dt_typename(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_typename(ob);
        }
     }

    private static native int jdt_uid(int ob);
    public static int dt_uid(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_uid(ob);
        }
     }

    private static native int jdt_uidrange(int ob, int typ);
    public static int dt_uidrange(int ob, int typ) {
        synchronized(Smiles.LockObject) {
            return jdt_uidrange(ob, typ);
        }
     }

    private static native int jdt_weight(int ob);
    public static int dt_weight(int ob) {
        synchronized(Smiles.LockObject) {
            return jdt_weight(ob);
        }
     }

    private static native int jdt_xatom(int a, int b);
    public static int dt_xatom(int a, int b) {
        synchronized(Smiles.LockObject) {
            return jdt_xatom(a, b);
        }
     }

    private static native String jdt_xsmiles(int ob, boolean iso, boolean explicit);
    public static String dt_xsmiles(int ob, boolean iso, boolean explicit) {
        synchronized(Smiles.LockObject) {
            return jdt_xsmiles(ob, iso, explicit);
        }
     }

    /* End of functions */

    // Constants

    public static final int     DT_SMILES_INCLUDED     = 1;
    public static final int     DX_ERR_NONE            = 0;
    public static final int     DX_ERR_NOTE            = 1;
    public static final int     DX_ERR_WARN            = 2;
    public static final int     DX_ERR_ERROR           = 3;
    public static final int     DX_ERR_FATAL           = 4;
    public static final int     DX_BTY_UNKNOWN         = 0;
    public static final int     DX_BTY_SINGLE          = 1;
    public static final int     DX_BTY_DOUBLE          = 2;
    public static final int     DX_BTY_TRIPLE          = 3;
    public static final int     DX_BTY_AROMAT          = 4;
    public static final int     DX_BTY_WILD            = 5;
    public static final int     DX_BTY_NONE            = 6;
    public static final int     DX_BTY_COUNT           = (DX_BTY_NONE+1);
    public static final int     DX_CHI_NONE            = 0;
    public static final int     DX_CHI_TH              = 3;
    public static final int     DX_CHI_AL              = 4;
    public static final int     DX_CHI_SP              = 16;
    public static final int     DX_CHI_TB              = 17;
    public static final int     DX_CHI_OH              = 18;
    public static final int     DT_XX_NO_CHI           = 0;
    public static final int     DT_XX_TH               = 3;
    public static final int     DT_XX_SP               = 16;
    public static final int     DT_XX_TB               = 17;
    public static final int     DT_XX_OH               = 18;
    public static final int     DX_CHI_THCCW           = DX_CHI_TH << 16 | 1;
    public static final int     DX_CHI_THCW            = DX_CHI_TH << 16 | 2;
    public static final int     DT_XX_TH1              = DX_CHI_THCCW;
    public static final int     DT_XX_THCCW            = DX_CHI_THCCW;
    public static final int     DT_XX_TH2              = DX_CHI_THCW;
    public static final int     DT_XX_THCW             = DX_CHI_THCW;
    public static final int     DX_CHI_NO_DBO          = 0;
    public static final int     DX_CHI_CIS             = 1;
    public static final int     DX_CHI_TRANS           = 2;
    public static final int     DT_XX_NO_DBO           = 0;
    public static final int     DT_XX_CIS              = 1;
    public static final int     DT_XX_TRANS            = 2;
    public static final int     DX_ROLE_REACTANT       = 1;
    public static final int     DX_ROLE_AGENT          = 2;
    public static final int     DX_ROLE_PRODUCT        = 3;
    public static final int     DX_ROLE_ANY            = 4;
    public static final int     DX_FORWARD             = 0;
    public static final int     DX_REVERSE             = 1;
    public static final int     DX_PROP_STRING         = 1;
    public static final int     DX_PROP_INTEGER        = 2;
    public static final int     DX_PROP_BOOLEAN        = 3;
    public static final int     DX_PROP_REAL           = 4;
    public static final int     DX_PROP_HANDLE         = 5;
    public static final int     DX_PROP_NOPROP         = 0;
    public static final int     TYP_ANY                = 1;
    public static final int     TYP_INTEGER            = 13;
    public static final int     TYP_REAL               = 14;
    public static final int     TYP_STRING             = 15;
    public static final int     TYP_MOLECULE           = 16;
    public static final int     TYP_CONFORMATION       = 17;
    public static final int     TYP_DEPICTION          = 18;
    public static final int     TYP_ATOM               = 19;
    public static final int     TYP_BOND               = 20;
    public static final int     TYP_CYCLE              = 21;
    public static final int     TYP_STREAM             = 22;
    public static final int     TYP_SEQUENCE           = 23;
    public static final int     TYP_SUBSTRUCT          = 24;
    public static final int     TYP_PATH               = 25;
    public static final int     TYP_PATTERN            = 26;
    public static final int     TYP_VBIND              = 27;
    public static final int     TYP_PATHSET            = 28;
    public static final int     TYP_SERVER             = 30;
    public static final int     TYP_DATABASE           = 31;
    public static final int     TYP_DATATREE           = 32;
    public static final int     TYP_DATAITEM           = 33;
    public static final int     TYP_DATAFIELD          = 34;
    public static final int     TYP_DATATYPE           = 35;
    public static final int     TYP_FIELDTYPE          = 36;
    public static final int     TYP_FINGERPRINT        = 40;
    public static final int     TYP_MERSERVER          = 50;
    public static final int     TYP_POOL               = 51;
    public static final int     TYP_HITLIST            = 52;
    public static final int     TYP_COLUMN             = 53;
    public static final int     TYP_MONOMERTABLE       = 60;
    public static final int     TYP_MONOMER            = 61;
    public static final int     TYP_MONOMERSET         = 62;
    public static final int     TYP_MULTIMER           = 63;
    public static final int     TYP_VARIMER            = 64;
    public static final int     TYP_MONOPATTERN        = 65;
    public static final int     TYP_VARIPATTERN        = 66;
    public static final int     TYP_PROGRAM            = 70;
    public static final int     TYP_REACTION           = 80;
    public static final int     TYP_TRANSFORM          = 81;
    public static final int     DX_ATN_H               = 1;
    public static final int     DX_ATN_He              = 2;
    public static final int     DX_ATN_Li              = 3;
    public static final int     DX_ATN_Be              = 4;
    public static final int     DX_ATN_B               = 5;
    public static final int     DX_ATN_C               = 6;
    public static final int     DX_ATN_N               = 7;
    public static final int     DX_ATN_O               = 8;
    public static final int     DX_ATN_F               = 9;
    public static final int     DX_ATN_Ne              = 10;
    public static final int     DX_ATN_Na              = 11;
    public static final int     DX_ATN_Mg              = 12;
    public static final int     DX_ATN_Al              = 13;
    public static final int     DX_ATN_Si              = 14;
    public static final int     DX_ATN_P               = 15;
    public static final int     DX_ATN_S               = 16;
    public static final int     DX_ATN_Cl              = 17;
    public static final int     DX_ATN_Ar              = 18;
    public static final int     DX_ATN_K               = 19;
    public static final int     DX_ATN_Ca              = 20;
    public static final int     DX_ATN_Sc              = 21;
    public static final int     DX_ATN_Ti              = 22;
    public static final int     DX_ATN_V               = 23;
    public static final int     DX_ATN_Cr              = 24;
    public static final int     DX_ATN_Mn              = 25;
    public static final int     DX_ATN_Fe              = 26;
    public static final int     DX_ATN_Co              = 27;
    public static final int     DX_ATN_Ni              = 28;
    public static final int     DX_ATN_Cu              = 29;
    public static final int     DX_ATN_Zn              = 30;
    public static final int     DX_ATN_Ga              = 31;
    public static final int     DX_ATN_Ge              = 32;
    public static final int     DX_ATN_As              = 33;
    public static final int     DX_ATN_Se              = 34;
    public static final int     DX_ATN_Br              = 35;
    public static final int     DX_ATN_Kr              = 36;
    public static final int     DX_ATN_Rb              = 37;
    public static final int     DX_ATN_Sr              = 38;
    public static final int     DX_ATN_Y               = 39;
    public static final int     DX_ATN_Zr              = 40;
    public static final int     DX_ATN_Nb              = 41;
    public static final int     DX_ATN_Mo              = 42;
    public static final int     DX_ATN_Tc              = 43;
    public static final int     DX_ATN_Ru              = 44;
    public static final int     DX_ATN_Rh              = 45;
    public static final int     DX_ATN_Pd              = 46;
    public static final int     DX_ATN_Ag              = 47;
    public static final int     DX_ATN_Cd              = 48;
    public static final int     DX_ATN_In              = 49;
    public static final int     DX_ATN_Sn              = 50;
    public static final int     DX_ATN_Sb              = 51;
    public static final int     DX_ATN_Te              = 52;
    public static final int     DX_ATN_I               = 53;
    public static final int     DX_ATN_Xe              = 54;
    public static final int     DX_ATN_Cs              = 55;
    public static final int     DX_ATN_Ba              = 56;
    public static final int     DX_ATN_La              = 57;
    public static final int     DX_ATN_Ce              = 58;
    public static final int     DX_ATN_Pr              = 59;
    public static final int     DX_ATN_Nd              = 60;
    public static final int     DX_ATN_Pm              = 61;
    public static final int     DX_ATN_Sm              = 62;
    public static final int     DX_ATN_Eu              = 63;
    public static final int     DX_ATN_Gd              = 64;
    public static final int     DX_ATN_Tb              = 65;
    public static final int     DX_ATN_Dy              = 66;
    public static final int     DX_ATN_Ho              = 67;
    public static final int     DX_ATN_Er              = 68;
    public static final int     DX_ATN_Tm              = 69;
    public static final int     DX_ATN_Yb              = 70;
    public static final int     DX_ATN_Lu              = 71;
    public static final int     DX_ATN_Hf              = 72;
    public static final int     DX_ATN_Ta              = 73;
    public static final int     DX_ATN_W               = 74;
    public static final int     DX_ATN_Re              = 75;
    public static final int     DX_ATN_Os              = 76;
    public static final int     DX_ATN_Ir              = 77;
    public static final int     DX_ATN_Pt              = 78;
    public static final int     DX_ATN_Au              = 79;
    public static final int     DX_ATN_Hg              = 80;
    public static final int     DX_ATN_Tl              = 81;
    public static final int     DX_ATN_Pb              = 82;
    public static final int     DX_ATN_Bi              = 83;
    public static final int     DX_ATN_Po              = 84;
    public static final int     DX_ATN_At              = 85;
    public static final int     DX_ATN_Rn              = 86;
    public static final int     DX_ATN_Fr              = 87;
    public static final int     DX_ATN_Ra              = 88;
    public static final int     DX_ATN_Ac              = 89;
    public static final int     DX_ATN_Th              = 90;
    public static final int     DX_ATN_Pa              = 91;
    public static final int     DX_ATN_U               = 92;
    public static final int     DX_ATN_Np              = 93;
    public static final int     DX_ATN_Pu              = 94;
    public static final int     DX_ATN_Am              = 95;
    public static final int     DX_ATN_Cm              = 96;
    public static final int     DX_ATN_Bk              = 97;
    public static final int     DX_ATN_Cf              = 98;
    public static final int     DX_ATN_Es              = 99;
    public static final int     DX_ATN_Fm              = 100;
    public static final int     DX_ATN_Md              = 101;
    public static final int     DX_ATN_No              = 102;
    public static final int     DX_ATN_Lr              = 103;
    public static final int     DX_ATN_MAX             = 103;
    public static final int     DX_ATN_WILD            = 0;

    // end of constants

    public static final int NULL_OB = 0;

    static { System.loadLibrary("dj");  }

    protected static Integer LockObject = new Integer(0);
    // Used to lock shared library usage

    /////////////// END
}
