//  /**********************************************************************
//  * This source code is public domain, and may be freely distributed,   *
//  * modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO    *
//  * WARRANTY OF ANY KIND.                                               *
//  **********************************************************************/

import java.io.*;
import com.daylight.Smiles;
import com.daylight.Http;

class test_http_cgi_revised extends Smiles {

    public static void main(String[] args) throws IOException {
	String name = new test_http_cgi_revised().getClass().getName();
	PrintWriter out = new PrintWriter(System.out, true);
	int http, xfer;
	boolean stat = true;

	// create a service */
	if (0 == (http = Http.dt_alloc_http_server(0))) {
	    System.err.println(name + ": dt_alloc_http_server failed\n");
	    System.exit(1);
	}

	// receive a request */
	xfer = Http.dt_http_get(http);

	if (NULL_OB != xfer) {
	    // send a response */
	    stat = Http.dt_http_put(xfer);
	    Smiles.dt_dealloc(xfer);
	}

	// return success or failure
	if (!stat)
	    System.exit(1);
	System.exit(0);
   }
}
