    /**********************************************************************
    * This source code is public domain, and may be freely distributed,   *
    * modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO    *
    * WARRANTY OF ANY KIND.                                               *
    **********************************************************************/

#include <stdio.h>
#include <string.h>
#include <jni.h>
#include <dt_smiles.h>
#include <dt_progob.h>
#include "djutils.h"
#include "djProgob.h"

JNIEXPORT jint JNICALL Java_com_daylight_Progob_jdt_1alloc_1program (
    JNIEnv *env, jclass cls, jint ob) {
   return dt_alloc_program(ob);
}

JNIEXPORT jint JNICALL Java_com_daylight_Progob_jdt_1welcome (
    JNIEnv *env, jclass cls, jint prog) {
   return dt_welcome(prog);
}

JNIEXPORT jint JNICALL Java_com_daylight_Progob_jdt_1converse (
    JNIEnv *env, jclass cls, jint prog, jint msgob) {
    return dt_converse(prog, msgob);
}

JNIEXPORT jint JNICALL Java_com_daylight_Progob_jdt_1delimiter (
    JNIEnv *env, jclass cls, jint prog) {
    return dt_delimiter(prog);
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Progob_jdt_1setdelimiter (
    JNIEnv *env, jclass cls, jint prog, jint value) {
    return dt_setdelimiter(prog, value) ? JNI_TRUE : JNI_FALSE;
}

