/* Definitions (used by MS-Windows for "dllexport" and "stdcall") */
#ifndef JNIEXPORT
#define JNIEXPORT
#endif
#ifndef JNICALL
#define JNICALL
#endif

#define cchar const char
 
/* Java & C datatype mapping */

/* binary */
char* GetBinPtr     (JNIEnv *env, jbyteArray jbyt);
char* GetBinPtrLen  (JNIEnv *env, int *len, jbyteArray jbyt);
void   ReleaseBinPtr (JNIEnv *env, jbyteArray jbyt, char *jptr);

/* characters */
char* GetCharPtr     (JNIEnv *env, jstring jstr);
char* GetCharPtrLen  (JNIEnv *env, int *len, jstring jstr);
void  ReleaseCharPtr (JNIEnv *env, jstring jstr, char *jptr);

/* floating point */
float* GetFloatPtr     (JNIEnv *env, jfloatArray jfarray);
float* GetFloatPtrLen  (JNIEnv *env, int *len, jfloatArray jfarray);
void    ReleaseFloatPtr (JNIEnv *env, jfloatArray jfarray, float* fptr);

/* integer */
int* GetIntPtr    (JNIEnv *env, jintArray jiarray);
int* GetIntPtrLen (JNIEnv *env, int *len, jintArray jiarray);
void ReleaseIntPtr (JNIEnv *env, jintArray jiarray, int *jptr);

/* data type converter */
jbyteArray Binary2Java (JNIEnv *env, int len, char *str);
jstring String2Java    (JNIEnv *env, int len, char *str);
