//  /**********************************************************************
//  * This source code is public domain, and may be freely distributed,   *
//  * modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO    *
//  * WARRANTY OF ANY KIND.                                               *
//  **********************************************************************/

import java.io.*;
import com.daylight.Smiles;
import com.daylight.Thor;

class thorping extends Smiles {
    public static void main(String[] args) throws IOException {
	PrintWriter out = new PrintWriter(System.out, true);
	String host, service, username, password, message;
	int server, isnew[] = new int[1], bytes;

	// initialize
	host = "localhost";
	service = "thor";
	username = "thorinfo";
	password = "";

	// arguments
	if (0 < args.length) {
	    // help
	    if (args[0].startsWith("-h")) {
		System.err.println("Usage: java " +
				   new thorping().getClass().getName() +
				   " [ host service username password ]");
		System.exit(0);
	    if (1 <= args.length)
		host = args[0];
	    if (2 <= args.length)
		service = args[1];
	    if (3 <= args.length)
		username = args[2];
	    if (4 <= args.length)
		password = args[3];
	    }
	}

	// get server
	if (NULL_OB == (server = Thor.dt_thor_server
			(host, service, username, password, isnew))) {
	    System.err.println("ERROR: unable to access server (" +
			       host + ":" + service + ":" +
			       username + "%" + password + "");
	    System.exit(1);
	}

	// check connection
	message = "Qwerty: Over.";
	if (0 == (bytes = Smiles.dt_ping(server, message)))
                System.err.println("WARNING: dt_ping failed");
	else
	    out.println("Connection to " + host + ":" + service + " succeeded");

	// deallocate
	Smiles.dt_dealloc(server);

	// close I/O
        out.close();
   }
}
